// SPDX-License-Identifier: Apache-2.0
// Copyright 2022 Authors of KubeArmor

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/kubearmor/KubeArmor/pkg/KubeArmorController/api/security.kubearmor.com/v1"
	scheme "github.com/kubearmor/KubeArmor/pkg/KubeArmorController/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// KubeArmorClusterPoliciesGetter has a method to return a KubeArmorClusterPolicyInterface.
// A group's client should implement this interface.
type KubeArmorClusterPoliciesGetter interface {
	KubeArmorClusterPolicies() KubeArmorClusterPolicyInterface
}

// KubeArmorClusterPolicyInterface has methods to work with KubeArmorClusterPolicy resources.
type KubeArmorClusterPolicyInterface interface {
	Create(ctx context.Context, kubeArmorClusterPolicy *v1.KubeArmorClusterPolicy, opts metav1.CreateOptions) (*v1.KubeArmorClusterPolicy, error)
	Update(ctx context.Context, kubeArmorClusterPolicy *v1.KubeArmorClusterPolicy, opts metav1.UpdateOptions) (*v1.KubeArmorClusterPolicy, error)
	UpdateStatus(ctx context.Context, kubeArmorClusterPolicy *v1.KubeArmorClusterPolicy, opts metav1.UpdateOptions) (*v1.KubeArmorClusterPolicy, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.KubeArmorClusterPolicy, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.KubeArmorClusterPolicyList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.KubeArmorClusterPolicy, err error)
	KubeArmorClusterPolicyExpansion
}

// kubeArmorClusterPolicies implements KubeArmorClusterPolicyInterface
type kubeArmorClusterPolicies struct {
	client rest.Interface
}

// newKubeArmorClusterPolicies returns a KubeArmorClusterPolicies
func newKubeArmorClusterPolicies(c *SecurityV1Client) *kubeArmorClusterPolicies {
	return &kubeArmorClusterPolicies{
		client: c.RESTClient(),
	}
}

// Get takes name of the kubeArmorClusterPolicy, and returns the corresponding kubeArmorClusterPolicy object, and an error if there is any.
func (c *kubeArmorClusterPolicies) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.KubeArmorClusterPolicy, err error) {
	result = &v1.KubeArmorClusterPolicy{}
	err = c.client.Get().
		Resource("kubearmorclusterpolicies").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of KubeArmorClusterPolicies that match those selectors.
func (c *kubeArmorClusterPolicies) List(ctx context.Context, opts metav1.ListOptions) (result *v1.KubeArmorClusterPolicyList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.KubeArmorClusterPolicyList{}
	err = c.client.Get().
		Resource("kubearmorclusterpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested kubeArmorClusterPolicies.
func (c *kubeArmorClusterPolicies) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("kubearmorclusterpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a kubeArmorClusterPolicy and creates it.  Returns the server's representation of the kubeArmorClusterPolicy, and an error, if there is any.
func (c *kubeArmorClusterPolicies) Create(ctx context.Context, kubeArmorClusterPolicy *v1.KubeArmorClusterPolicy, opts metav1.CreateOptions) (result *v1.KubeArmorClusterPolicy, err error) {
	result = &v1.KubeArmorClusterPolicy{}
	err = c.client.Post().
		Resource("kubearmorclusterpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorClusterPolicy).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a kubeArmorClusterPolicy and updates it. Returns the server's representation of the kubeArmorClusterPolicy, and an error, if there is any.
func (c *kubeArmorClusterPolicies) Update(ctx context.Context, kubeArmorClusterPolicy *v1.KubeArmorClusterPolicy, opts metav1.UpdateOptions) (result *v1.KubeArmorClusterPolicy, err error) {
	result = &v1.KubeArmorClusterPolicy{}
	err = c.client.Put().
		Resource("kubearmorclusterpolicies").
		Name(kubeArmorClusterPolicy.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorClusterPolicy).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *kubeArmorClusterPolicies) UpdateStatus(ctx context.Context, kubeArmorClusterPolicy *v1.KubeArmorClusterPolicy, opts metav1.UpdateOptions) (result *v1.KubeArmorClusterPolicy, err error) {
	result = &v1.KubeArmorClusterPolicy{}
	err = c.client.Put().
		Resource("kubearmorclusterpolicies").
		Name(kubeArmorClusterPolicy.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorClusterPolicy).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the kubeArmorClusterPolicy and deletes it. Returns an error if one occurs.
func (c *kubeArmorClusterPolicies) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Resource("kubearmorclusterpolicies").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *kubeArmorClusterPolicies) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("kubearmorclusterpolicies").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched kubeArmorClusterPolicy.
func (c *kubeArmorClusterPolicies) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.KubeArmorClusterPolicy, err error) {
	result = &v1.KubeArmorClusterPolicy{}
	err = c.client.Patch(pt).
		Resource("kubearmorclusterpolicies").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
