// SPDX-License-Identifier: Apache-2.0
// Copyright 2022 Authors of KubeArmor

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/kubearmor/KubeArmor/pkg/KubeArmorController/api/security.kubearmor.com/v1"
	scheme "github.com/kubearmor/KubeArmor/pkg/KubeArmorController/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// KubeArmorHostPoliciesGetter has a method to return a KubeArmorHostPolicyInterface.
// A group's client should implement this interface.
type KubeArmorHostPoliciesGetter interface {
	KubeArmorHostPolicies() KubeArmorHostPolicyInterface
}

// KubeArmorHostPolicyInterface has methods to work with KubeArmorHostPolicy resources.
type KubeArmorHostPolicyInterface interface {
	Create(ctx context.Context, kubeArmorHostPolicy *v1.KubeArmorHostPolicy, opts metav1.CreateOptions) (*v1.KubeArmorHostPolicy, error)
	Update(ctx context.Context, kubeArmorHostPolicy *v1.KubeArmorHostPolicy, opts metav1.UpdateOptions) (*v1.KubeArmorHostPolicy, error)
	UpdateStatus(ctx context.Context, kubeArmorHostPolicy *v1.KubeArmorHostPolicy, opts metav1.UpdateOptions) (*v1.KubeArmorHostPolicy, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.KubeArmorHostPolicy, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.KubeArmorHostPolicyList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.KubeArmorHostPolicy, err error)
	KubeArmorHostPolicyExpansion
}

// kubeArmorHostPolicies implements KubeArmorHostPolicyInterface
type kubeArmorHostPolicies struct {
	client rest.Interface
}

// newKubeArmorHostPolicies returns a KubeArmorHostPolicies
func newKubeArmorHostPolicies(c *SecurityV1Client) *kubeArmorHostPolicies {
	return &kubeArmorHostPolicies{
		client: c.RESTClient(),
	}
}

// Get takes name of the kubeArmorHostPolicy, and returns the corresponding kubeArmorHostPolicy object, and an error if there is any.
func (c *kubeArmorHostPolicies) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.KubeArmorHostPolicy, err error) {
	result = &v1.KubeArmorHostPolicy{}
	err = c.client.Get().
		Resource("kubearmorhostpolicies").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of KubeArmorHostPolicies that match those selectors.
func (c *kubeArmorHostPolicies) List(ctx context.Context, opts metav1.ListOptions) (result *v1.KubeArmorHostPolicyList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.KubeArmorHostPolicyList{}
	err = c.client.Get().
		Resource("kubearmorhostpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested kubeArmorHostPolicies.
func (c *kubeArmorHostPolicies) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("kubearmorhostpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a kubeArmorHostPolicy and creates it.  Returns the server's representation of the kubeArmorHostPolicy, and an error, if there is any.
func (c *kubeArmorHostPolicies) Create(ctx context.Context, kubeArmorHostPolicy *v1.KubeArmorHostPolicy, opts metav1.CreateOptions) (result *v1.KubeArmorHostPolicy, err error) {
	result = &v1.KubeArmorHostPolicy{}
	err = c.client.Post().
		Resource("kubearmorhostpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorHostPolicy).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a kubeArmorHostPolicy and updates it. Returns the server's representation of the kubeArmorHostPolicy, and an error, if there is any.
func (c *kubeArmorHostPolicies) Update(ctx context.Context, kubeArmorHostPolicy *v1.KubeArmorHostPolicy, opts metav1.UpdateOptions) (result *v1.KubeArmorHostPolicy, err error) {
	result = &v1.KubeArmorHostPolicy{}
	err = c.client.Put().
		Resource("kubearmorhostpolicies").
		Name(kubeArmorHostPolicy.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorHostPolicy).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *kubeArmorHostPolicies) UpdateStatus(ctx context.Context, kubeArmorHostPolicy *v1.KubeArmorHostPolicy, opts metav1.UpdateOptions) (result *v1.KubeArmorHostPolicy, err error) {
	result = &v1.KubeArmorHostPolicy{}
	err = c.client.Put().
		Resource("kubearmorhostpolicies").
		Name(kubeArmorHostPolicy.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorHostPolicy).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the kubeArmorHostPolicy and deletes it. Returns an error if one occurs.
func (c *kubeArmorHostPolicies) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Resource("kubearmorhostpolicies").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *kubeArmorHostPolicies) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("kubearmorhostpolicies").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched kubeArmorHostPolicy.
func (c *kubeArmorHostPolicies) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.KubeArmorHostPolicy, err error) {
	result = &v1.KubeArmorHostPolicy{}
	err = c.client.Patch(pt).
		Resource("kubearmorhostpolicies").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
