// SPDX-License-Identifier: Apache-2.0
// Copyright 2022 Authors of KubeArmor

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/kubearmor/KubeArmor/pkg/KubeArmorController/api/security.kubearmor.com/v1"
	scheme "github.com/kubearmor/KubeArmor/pkg/KubeArmorController/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// KubeArmorPoliciesGetter has a method to return a KubeArmorPolicyInterface.
// A group's client should implement this interface.
type KubeArmorPoliciesGetter interface {
	KubeArmorPolicies(namespace string) KubeArmorPolicyInterface
}

// KubeArmorPolicyInterface has methods to work with KubeArmorPolicy resources.
type KubeArmorPolicyInterface interface {
	Create(ctx context.Context, kubeArmorPolicy *v1.KubeArmorPolicy, opts metav1.CreateOptions) (*v1.KubeArmorPolicy, error)
	Update(ctx context.Context, kubeArmorPolicy *v1.KubeArmorPolicy, opts metav1.UpdateOptions) (*v1.KubeArmorPolicy, error)
	UpdateStatus(ctx context.Context, kubeArmorPolicy *v1.KubeArmorPolicy, opts metav1.UpdateOptions) (*v1.KubeArmorPolicy, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.KubeArmorPolicy, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.KubeArmorPolicyList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.KubeArmorPolicy, err error)
	KubeArmorPolicyExpansion
}

// kubeArmorPolicies implements KubeArmorPolicyInterface
type kubeArmorPolicies struct {
	client rest.Interface
	ns     string
}

// newKubeArmorPolicies returns a KubeArmorPolicies
func newKubeArmorPolicies(c *SecurityV1Client, namespace string) *kubeArmorPolicies {
	return &kubeArmorPolicies{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the kubeArmorPolicy, and returns the corresponding kubeArmorPolicy object, and an error if there is any.
func (c *kubeArmorPolicies) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.KubeArmorPolicy, err error) {
	result = &v1.KubeArmorPolicy{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kubearmorpolicies").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of KubeArmorPolicies that match those selectors.
func (c *kubeArmorPolicies) List(ctx context.Context, opts metav1.ListOptions) (result *v1.KubeArmorPolicyList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.KubeArmorPolicyList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kubearmorpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested kubeArmorPolicies.
func (c *kubeArmorPolicies) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("kubearmorpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a kubeArmorPolicy and creates it.  Returns the server's representation of the kubeArmorPolicy, and an error, if there is any.
func (c *kubeArmorPolicies) Create(ctx context.Context, kubeArmorPolicy *v1.KubeArmorPolicy, opts metav1.CreateOptions) (result *v1.KubeArmorPolicy, err error) {
	result = &v1.KubeArmorPolicy{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("kubearmorpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorPolicy).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a kubeArmorPolicy and updates it. Returns the server's representation of the kubeArmorPolicy, and an error, if there is any.
func (c *kubeArmorPolicies) Update(ctx context.Context, kubeArmorPolicy *v1.KubeArmorPolicy, opts metav1.UpdateOptions) (result *v1.KubeArmorPolicy, err error) {
	result = &v1.KubeArmorPolicy{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("kubearmorpolicies").
		Name(kubeArmorPolicy.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorPolicy).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *kubeArmorPolicies) UpdateStatus(ctx context.Context, kubeArmorPolicy *v1.KubeArmorPolicy, opts metav1.UpdateOptions) (result *v1.KubeArmorPolicy, err error) {
	result = &v1.KubeArmorPolicy{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("kubearmorpolicies").
		Name(kubeArmorPolicy.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorPolicy).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the kubeArmorPolicy and deletes it. Returns an error if one occurs.
func (c *kubeArmorPolicies) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kubearmorpolicies").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *kubeArmorPolicies) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kubearmorpolicies").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched kubeArmorPolicy.
func (c *kubeArmorPolicies) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.KubeArmorPolicy, err error) {
	result = &v1.KubeArmorPolicy{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("kubearmorpolicies").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
