// SPDX-License-Identifier: Apache-2.0
// Copyright 2023 Authors of KubeArmor

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/kubearmor/KubeArmor/pkg/KubeArmorOperator/api/operator.kubearmor.com/v1"
	scheme "github.com/kubearmor/KubeArmor/pkg/KubeArmorOperator/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// KubeArmorConfigsGetter has a method to return a KubeArmorConfigInterface.
// A group's client should implement this interface.
type KubeArmorConfigsGetter interface {
	KubeArmorConfigs(namespace string) KubeArmorConfigInterface
}

// KubeArmorConfigInterface has methods to work with KubeArmorConfig resources.
type KubeArmorConfigInterface interface {
	Create(ctx context.Context, kubeArmorConfig *v1.KubeArmorConfig, opts metav1.CreateOptions) (*v1.KubeArmorConfig, error)
	Update(ctx context.Context, kubeArmorConfig *v1.KubeArmorConfig, opts metav1.UpdateOptions) (*v1.KubeArmorConfig, error)
	UpdateStatus(ctx context.Context, kubeArmorConfig *v1.KubeArmorConfig, opts metav1.UpdateOptions) (*v1.KubeArmorConfig, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.KubeArmorConfig, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.KubeArmorConfigList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.KubeArmorConfig, err error)
	KubeArmorConfigExpansion
}

// kubeArmorConfigs implements KubeArmorConfigInterface
type kubeArmorConfigs struct {
	client rest.Interface
	ns     string
}

// newKubeArmorConfigs returns a KubeArmorConfigs
func newKubeArmorConfigs(c *OperatorV1Client, namespace string) *kubeArmorConfigs {
	return &kubeArmorConfigs{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the kubeArmorConfig, and returns the corresponding kubeArmorConfig object, and an error if there is any.
func (c *kubeArmorConfigs) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.KubeArmorConfig, err error) {
	result = &v1.KubeArmorConfig{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kubearmorconfigs").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of KubeArmorConfigs that match those selectors.
func (c *kubeArmorConfigs) List(ctx context.Context, opts metav1.ListOptions) (result *v1.KubeArmorConfigList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.KubeArmorConfigList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kubearmorconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested kubeArmorConfigs.
func (c *kubeArmorConfigs) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("kubearmorconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a kubeArmorConfig and creates it.  Returns the server's representation of the kubeArmorConfig, and an error, if there is any.
func (c *kubeArmorConfigs) Create(ctx context.Context, kubeArmorConfig *v1.KubeArmorConfig, opts metav1.CreateOptions) (result *v1.KubeArmorConfig, err error) {
	result = &v1.KubeArmorConfig{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("kubearmorconfigs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorConfig).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a kubeArmorConfig and updates it. Returns the server's representation of the kubeArmorConfig, and an error, if there is any.
func (c *kubeArmorConfigs) Update(ctx context.Context, kubeArmorConfig *v1.KubeArmorConfig, opts metav1.UpdateOptions) (result *v1.KubeArmorConfig, err error) {
	result = &v1.KubeArmorConfig{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("kubearmorconfigs").
		Name(kubeArmorConfig.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorConfig).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *kubeArmorConfigs) UpdateStatus(ctx context.Context, kubeArmorConfig *v1.KubeArmorConfig, opts metav1.UpdateOptions) (result *v1.KubeArmorConfig, err error) {
	result = &v1.KubeArmorConfig{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("kubearmorconfigs").
		Name(kubeArmorConfig.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(kubeArmorConfig).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the kubeArmorConfig and deletes it. Returns an error if one occurs.
func (c *kubeArmorConfigs) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kubearmorconfigs").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *kubeArmorConfigs) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kubearmorconfigs").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched kubeArmorConfig.
func (c *kubeArmorConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.KubeArmorConfig, err error) {
	result = &v1.KubeArmorConfig{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("kubearmorconfigs").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
